package sun.java2d.opengl;

import sun.java2d.loops.GraphicsPrimitive;
import sun.font.GlyphList;
import sun.java2d.pipe.BufferedContext;
import java.awt.Composite;
import sun.java2d.SunGraphics2D;
import sun.java2d.pipe.RenderQueue;
import sun.java2d.pipe.BufferedTextPipe;

class OGLTextRenderer extends BufferedTextPipe
{
    OGLTextRenderer(RenderQueue rq) {
        super(rq);
    }
    
    @Override
    protected native void drawGlyphList(int p0, boolean p1, boolean p2, boolean p3, int p4, float p5, float p6, long[] p7, float[] p8);
    
    @Override
    protected void validateContext(SunGraphics2D sg2d, Composite comp) {
        OGLSurfaceData oglSurfaceData = (OGLSurfaceData)sg2d.surfaceData;
        BufferedContext.validateContext(oglSurfaceData, oglSurfaceData, sg2d.getCompClip(), comp, null, sg2d.paint, sg2d, 0);
    }
    
    OGLTextRenderer traceWrap() {
        return new OGLTextRenderer.Tracer(this);
    }
    
    private static class Tracer extends OGLTextRenderer
    {
        Tracer(OGLTextRenderer oglTextRenderer) {
            super(oglTextRenderer.rq);
        }
        
        @Override
        protected void drawGlyphList(SunGraphics2D sg2d, GlyphList gl) {
            GraphicsPrimitive.tracePrimitive("OGLDrawGlyphs");
            super.drawGlyphList(sg2d, gl);
        }
    }
}
